#Compile       Exe
#Include       "Win32api.inc"
$CLSID_CE      = GUID$("{20000000-0000-0000-0000-000000000040}")
$IID_ICOMCtrl  = GUID$("{20000000-0000-0000-0000-000000000041}")
$IID_IOutGoing = GUID$("{20000000-0000-0000-0000-000000000042}")
#Include       "CDClient1.inc"
Global         MsgHdlr() As MessageHandler
Global         pComCtrl  As IComCtrl


Class EventClass As Event
  Interface IOutGoing $IID_IOutGoing As Event : Inherit IAutomation
    Method ControlEvent(Byval iMessage As Long)
      Local iCtrlId, iWndHdl As Long
      Local strMessage As String

      If iMessage=%WM_LBUTTONDOWN Then
         Select Case As Long pComCtrl.GetColor()
           Case RGB(255,255,0)
             strMessage = "The COM Control Is Yellow!  Its Control ID Is" & $CrLf
           Case RGB(0,0,255)
             strMessage = "The COM Control Is Blue!  Its Control ID Is" & $CrLf
           Case RGB(0,255,0)
             strMessage = "The COM Control Is Green!  Its Control ID Is" & $CrLf
           Case RGB(255,0,0)
             strMessage = "The COM Control Is Red!  Its Control ID Is" & $CrLf
         End Select
         iCtrlId=pComCtrl.GetCtrlId()
         iWndHdl=pComCtrl.GetHWND
         strMessage = strMessage & Str$(iCtrlId) & " And Its hWnd Is " & Str$(iWndHdl) & "."
         MsgBox(strMessage)
      End If
    End Method
  End Interface
End Class


Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long
  Local hContainer,hButton,dwStyle As Dword
  Local pCreateStruct As CREATESTRUCT Ptr
  Global pSink As IOutGoing

  pCreateStruct=wea.lParam
  wea.hInst=@pCreateStruct.hInstance
  dwStyle=%WS_CHILD Or %WS_VISIBLE Or %WS_THICKFRAME
  hButton=CreateWindowEx(0,"button","Blue",%WS_CHILD Or %WS_VISIBLE,8,10,80,25,wea.hWnd,%IDC_BLUE,wea.hInst,ByVal 0)
  hButton=CreateWindowEx(0,"button","Green",%WS_CHILD Or %WS_VISIBLE,8,40,80,25,wea.hWnd,%IDC_GREEN,wea.hInst,ByVal 0)
  hButton=CreateWindowEx(0,"button","Red",%WS_CHILD Or %WS_VISIBLE,8,70,80,25,wea.hWnd,%IDC_RED,wea.hInst,ByVal 0)
  hContainer=CreateWindowEx(%WS_EX_CLIENTEDGE,"static","",dwStyle,100,12,325,80,Wea.hWnd,1600,Wea.hInst,Byval 0)
  Call AllocConsole()
  Let pComCtrl = NewCom "ComCtrl.CD"
  Let pSink    = Class  "EventClass"
  Events From pComCtrl Call pSink
  pComCtrl.Initialize()
  pComCtrl.CreateControl(hContainer)

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnCommand(wea As WndEventArgs) As Long
  Select Case As Long LoWrd(Wea.wParam)
    Case %IDC_BLUE
      pComCtrl.SetColor(RGB(0,0,255))
    Case %IDC_GREEN
      pComCtrl.SetColor(RGB(0,255,0))
    Case %IDC_RED
      pComCtrl.SetColor(RGB(255,0,0))
  End Select

  fnWndProc_OnCommand=0
End Function


Function fnWndProc_OnClose(wea As WndEventArgs) As Long
  Set pComCtrl=Nothing
  Events End pSink
  Set pSink=Nothing
  MsgBox("Just Released COM Control")
  Call PostQuitMessage(0)

  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 2
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnWndProc=iReturn
       Exit Function
    End If
  Next i

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Sub AttachMessageHandlers()
  ReDim MsgHdlr(2) As MessageHandler  'Associate Windows Message With Message Handlers
  MsgHdlr(0).wMessage=%WM_CREATE   :   MsgHdlr(0).dwFnPtr=CodePtr(fnWndProc_OnCreate)
  MsgHdlr(1).wMessage=%WM_COMMAND  :   MsgHdlr(1).dwFnPtr=CodePtr(fnWndProc_OnCommand)
  MsgHdlr(2).wMessage=%WM_CLOSE    :   MsgHdlr(2).dwFnPtr=CodePtr(fnWndProc_OnClose)
End Sub


Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local szAppName As Asciiz*16
  Local wc As WndClassEx
  Local hWnd As Dword
  Local Msg As tagMsg

  Call AttachMessageHandlers()                    : szAppName="CEClient2"
  wc.lpszClassName=VarPtr(szAppName)              : wc.lpfnWndProc=CodePtr(fnWndProc)
  wc.cbSize=SizeOf(wc)                            : wc.style=%CS_HREDRAW Or %CS_VREDRAW
  wc.cbClsExtra=0                                 : wc.cbWndExtra=0
  wc.hInstance=hIns                               : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)  : wc.hbrBackground=%COLOR_BTNFACE+1
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)
  hWnd=CreateWindow(szAppName,"Visual COM Control Example",%WS_OVERLAPPEDWINDOW Xor %WS_MAXIMIZEBOX,400,550,440,140,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function

'Entering DllGetClassObjectImpl()
'  Varptr(CDClassFactory) =  15120372
'  Entering IClassFactory_QueryInterface()
'    this =  15120372
'    Somebody's Looking For IID_IUnknown Or IID_IClassFactory!
'  Leaving IClassFactory_QueryInterface()
'
'  IClassFactory_QueryInterface() Succeeded!
'Leaving DllGetClassObjectImpl()
'
'Entering IClassFactory_CreateInstance()
'  pCD                        =  11956040
'  Varptr(@pCD.lpComCtrlVtbl) =  11956040
'  Varptr(@pCD.lpICPCVtbl)    =  11956044
'  Varptr(@pCD.lpICPVtbl)     =  11956048
'  @ppv                       =  0  << Before QueryInterface() Call
'  Entering IComCtrl_QueryInterface()
'    Trying To Get IComCtrl
'    this =  11956040
'  Leaving IComCtrl_QueryInterface()
'  @ppv                       =  11956040  << After QueryInterface() Call
'Leaving IClassFactory_CreateInstance()
'
'Entering IComCtrl_Release()
'  @pCD.m_cRef =  2
'Leaving IComCtrl_Release()
'
'Entering IComCtrl_QueryInterface()
'  Trying To Get IComCtrl
'  this =  11956040
'Leaving IComCtrl_QueryInterface()
'
'Entering IComCtrl_Release()
'  @pCD.m_cRef =  2
'Leaving IComCtrl_Release()
'
'Entering IComCtrl_QueryInterface()
'  Trying To Get IConnectionPointContainer
'  this =  11956040
'  this =  11956044
'Leaving IComCtrl_QueryInterface()
'
'Entering IConnectionPointContainer_FindConnectionPoint()
'  this  =  11956044
'  @ppCP =  0
'  @ppCP =  11956048
'Leaving IConnectionPointContainer_FindConnectionPoint()
'
'Entering IConnectionPoint_Advise()!  Grab Your Hardhat And Hang On Tight!
'  pUnkSink      =  11956076
'  @pUnkSink     =  4210840
'  Vtbl          =  4210840
'  @Vtbl[0]      =  4215600
'  g_ptrOutGoing =  0  << Before Call Of QueryInterface() On Sink
'  g_ptrOutGoing =  11956076  << After Call Of QueryInterface() On Sink
'  Call Dword Succeeded!
'Leaving IConnectionPoint_Advise() And Still In One Piece!
'
'Entering IConnectionPoint_Release()
'Leaving IConnectionPoint_Release()
'
'Entering IConnectionPointContainer_Release()
'Leaving IConnectionPointContainer_Release()
'
'Entering IComCtrl_Initialize()
'  this =  11956040
'Leaving IComCtrl_Initialize()
'
'Entering IComCtrl_CreateControl()
'  this =  11956040
'Leaving IComCtrl_CreateControl()
'
'WM_LBUTTONDOWN
'g_ptrOutGoing =  11956076
'@Vtbl         =  4215600
'@Vtbl[0]      =  4215600
'
'WM_LBUTTONDOWN
'g_ptrOutGoing =  11956076
'@Vtbl         =  4215600
'@Vtbl[0]      =  4215600
'
'Entering IComCtrl_Release()
'  @pCD.m_cRef =  2
'Leaving IComCtrl_Release()
'
'Entering IComCtrl_QueryInterface()
'  Trying To Get IConnectionPointContainer
'  this =  11956040
'  this =  11956044
'Leaving IComCtrl_QueryInterface()
'
'Entering IConnectionPointContainer_FindConnectionPoint()
'  this  =  11956044
'  @ppCP =  0
'  @ppCP =  11956048
'Leaving IConnectionPointContainer_FindConnectionPoint()
'
'Entering IConnectionPoint_Unadvise()
'  Release() Returned  1
'Leaving IConnectionPoint_Unadvise()
'
'Entering IComCtrl_Release()
'  @pCD.m_cRef =  3
'Leaving IComCtrl_Release()
'
'Entering IConnectionPoint_Release()
'Leaving IConnectionPoint_Release()
'
'Entering IConnectionPointContainer_Release()
'  @pCD.m_cRef = 0 And Will Now Delete pCD!
'Leaving IConnectionPointContainer_Release()
'
